package com.mcwl.web.controller.communityCenter;


import cn.hutool.core.bean.BeanUtil;
import com.mcwl.common.core.domain.AjaxResult;
import com.mcwl.common.core.page.PageDomain;
import com.mcwl.common.core.page.TableDataInfo;
import com.mcwl.communityCenter.domain.Publish;
import com.mcwl.communityCenter.domain.dto.PublishRes;
import com.mcwl.communityCenter.domain.vo.PublishVo;
import com.mcwl.communityCenter.service.PublishService;
import lombok.RequiredArgsConstructor;
import org.springframework.web.bind.annotation.*;

import java.util.Objects;

/**
 * 发布
 */
@RestController
@RequestMapping("publish")
@RequiredArgsConstructor
public class PublishController {

    private final PublishService publishService;


    /**
     * 获取发布列表
     *
     * @return
     */
    @PostMapping("list")
    public TableDataInfo getCommunityList(@RequestBody PageDomain pageDomain) {
        return publishService.listByPage(pageDomain);
    }

    /**
     * 获取发布详情
     */
    @GetMapping("detail")
    public AjaxResult getPublishDetail(Long id) {

        PublishVo publishVo = publishService.getDetail(id);
        if (Objects.isNull(publishVo)) {
            return AjaxResult.error("获取详情失败");
        }
        return AjaxResult.success(publishVo);
    }

    /**
     * 添加
     */
    @PostMapping("add")
    public AjaxResult addPublish(@RequestBody PublishRes publishRes) {
        Publish publish = new Publish();
        BeanUtil.copyProperties(publishRes, publish);
        return AjaxResult.success(publishService.save(publish));
    }

    /**
     * 删除
     */
    @GetMapping("remove")
    public AjaxResult deletePublish(Long id) {
        return AjaxResult.success(publishService.removeById(id));
    }

}
