package com.mcwl.communityCenter.domain;


import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.mcwl.common.core.domain.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 提问
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("cc_question")
public class Question extends BaseEntity {

    @TableId
    private Long id;


    /**
     * 用户id - 租户id
     */
    @TableField(fill = FieldFill.INSERT)
    private Long tenantId;

    /**
     * 提问用户id
     */
    private Long questionUserId;

    /**
     * 提问内容
     */
    private String content;

    /**
     * 答复用户id
     */
    private Long replyUserId;

    /**
     * 回复内容
     */
    private String reply;

    /**
     * 提问图片
     */
    private String questionUrl;

    /**
     * 是否匿名
     */
    private Integer isAnonymous;

    /**
     * 状态
     */
    private Integer status;



}
