package com.mcwl.communityCenter.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.OrderItem;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.github.pagehelper.PageInfo;
import com.mcwl.common.constant.HttpStatus;
import com.mcwl.common.core.page.PageDomain;
import com.mcwl.common.core.page.TableDataInfo;
import com.mcwl.common.utils.SecurityUtils;
import com.mcwl.communityCenter.domain.Publish;
import com.mcwl.communityCenter.domain.vo.PublishVo;
import com.mcwl.communityCenter.mapper.PublishMapper;
import com.mcwl.communityCenter.service.PublishService;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

@Service
public class PublishServiceImpl extends ServiceImpl<PublishMapper, Publish> implements PublishService {
    @Override
    public TableDataInfo listByPage(PageDomain pageDomain) {
        // 分页查询
        Page<Publish> page = new Page<>(pageDomain.getPageNum(), pageDomain.getPageSize());
        boolean isAsc = Objects.equals(pageDomain.getIsAsc(), "asc");
        OrderItem orderItem = new OrderItem(pageDomain.getOrderByColumn(), isAsc);
        page.addOrder(orderItem);

        // 条件设置
        LambdaQueryWrapper<Publish> lqw = new LambdaQueryWrapper<>();

        // 查询
        baseMapper.selectPage(page, lqw);

        // 返回数据
        List<PublishVo> publishVoList = new ArrayList<>();

        // 封装数据
        List<Publish> publishList = page.getRecords();
        for (Publish publish : publishList) {
            PublishVo publishVo = new PublishVo();
            BeanUtil.copyProperties(publish, publishVo);
            publishVo.setUserName(SecurityUtils.getUsername());
            publishVo.setAvatar(SecurityUtils.getLoginUser().getUser().getAvatar());
            // TODO 评论数
            publishVo.setCommentNum(0);
            publishVoList.add(publishVo);

        }


        TableDataInfo rspData = new TableDataInfo();
        rspData.setCode(HttpStatus.SUCCESS);
        rspData.setMsg("查询成功");
        rspData.setRows(publishVoList);
        rspData.setTotal(page.getTotal());

        return rspData;
    }

    @Override
    public PublishVo getDetail(Long id) {

        Publish publish = baseMapper.selectById(id);
        if (Objects.isNull(publish)) {
            return null;
        }
        PublishVo publishVo = new PublishVo();
        BeanUtil.copyProperties(publish, publishVo);
        publishVo.setUserName(SecurityUtils.getUsername());
        publishVo.setAvatar(SecurityUtils.getLoginUser().getUser().getAvatar());
        return publishVo;
    }
}
